﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Persistence.Storage;
using Telerik.Windows.Persistence;
using System.IO;
using Microsoft.Win32;
using System.Xml.Serialization;
using Telerik.Windows.Persistence.Core;

namespace WPFTest
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		private PersistenceManager manager;

		public MainWindow()
		{
			InitializeComponent();
			this.manager = new PersistenceManager();
			this.manager.AllowCrossVersion = true;
		}

		public static void CopyStream(Stream input, Stream output)
		{
			byte[] buffer = new byte[8 * 1024];
			int len;
			while ((len = input.Read(buffer, 0, buffer.Length)) > 0)
			{
				output.Write(buffer, 0, len);
			}
		}

		private void RadButton_Click(object sender, RoutedEventArgs e)
		{
			var stream = this.manager.Save(this.listBox);

			var dialog = new SaveFileDialog
			{
				DefaultExt = "xml",
				Filter = "test files|*.xml|All Files (*.*)|*.*",
				FileName = "test.xml"

			};
			if (dialog.ShowDialog() == true)
			{
				using (var fileStream = File.Create(dialog.FileName))
				{
					CopyStream(stream, fileStream);
				}
			}
		}

		private void RadButton_Click_1(object sender, RoutedEventArgs e)
		{
			var dialog = new OpenFileDialog { Multiselect = false, Filter = "test (.xml)|*.xml|All Files (*.*)|*.*" };
			if (dialog.ShowDialog() == true)
			{
				using (var fileStream = File.OpenRead(dialog.FileName))
				{
					this.manager.Load(this.listBox, fileStream);
				}
			}
		}
	}
}
